--1 Leite
select
    an.numero
    , an.dtnascimento
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue
    , ((select count(*) from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio <= lac.dtinicio) + coalesce(an.numpartoentrada,0)) as ordem_lac
    , lac.dtinicio
    , lac.dtfim
    , (select sp.descricao from sp_grupoanimalespecifico(current_date, (select conf.valor from configuracao conf where conf.nome = 'TipoGrupoPrincipal'), an.cdanimal) sp) as Grupo
    , cast('Leite' as varchar (50)) as Evento
    , l.dtleite as Data_Evento
    , cast(l.pesototal as decimal (5,3)) as Complemento_Evento
    , cast(null as varchar (300)) as Complemento_Evento_Texto
    , (l.dtleite - lac.dtinicio) as DEL
from
    animal an
    left join lactacao lac on lac.cdanimal = an.cdanimal
    join leite l on l.cdlactacao = lac.cdlactacao
where
  an.cdcategoria in (6,7)
  and an.animalrebanho = 1
  and an.tipoanimal = 'A'

union all

--2 IA e DG
select
    an.numero
    , an.dtnascimento
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue
    , ((select count(*) from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio <= lac.dtinicio) + coalesce(an.numpartoentrada,0)) as ordem_lac
    , lac.dtinicio
    , lac.dtfim
    , (select sp.descricao from sp_grupoanimalespecifico(rep.data, (select conf.valor from configuracao conf where conf.nome = 'TipoGrupoPrincipal'), an.cdanimal) sp) as Grupo
    , cast((case rep.cdtiporeproducao
        when 1 then 'IA'
        when 2 then 'COB'
        when 3 then 'TE'
        when 4 then 'DG'
        else null end) as varchar (50)) as Evento
    , rep.data as Data_Evento
    , cast(null as decimal (5,3)) as Complemento_Evento
    , cast((case when rep.diagnostico = 'P' then 'Positivo' when rep.diagnostico = 'N' then 'Negativo' else '' end) as varchar (300)) as Complemento_Evento_Texto
    , (rep.data - lac.dtinicio) as DEL
from
    animal an
    left join lactacao lac on lac.cdanimal = an.cdanimal
    join reproducao rep on rep.cdanimal = an.cdanimal and ((rep.cdtiporeproducao in (1,2,3))or(rep.diagnostico is not null))
where
  an.cdcategoria in (6,7)
  and an.animalrebanho = 1
  and an.tipoanimal = 'A'

union all

--3 Medida
select
    an.numero
    , an.dtnascimento
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue
    , ((select count(*) from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio <= lac.dtinicio) + coalesce(an.numpartoentrada,0)) as ordem_lac
    , lac.dtinicio
    , lac.dtfim
    , (select sp.descricao from sp_grupoanimalespecifico(med.dtmedida, (select conf.valor from configuracao conf where conf.nome = 'TipoGrupoPrincipal'), an.cdanimal) sp) as Grupo
    , cast(tmed.descricao as varchar (50)) as Evento
    , med.dtmedida as Data_Evento
    , cast(med.valor as decimal (5,3)) as Complemento_Evento
    , cast(null as varchar (300)) as Complemento_Evento_Texto
    , (med.dtmedida - lac.dtinicio) as DEL
from
    animal an
    left join lactacao lac on lac.cdanimal = an.cdanimal
    join medida med on med.cdanimal = an.cdanimal
    join tipomedida tmed on tmed.cdtipomedida = med.cdtipomedida
where
  an.cdcategoria in (6,7)
  and an.animalrebanho = 1
  and an.tipoanimal = 'A'

union all

--4 Doena
select
    an.numero
    , an.dtnascimento
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue
    , ((select count(*) from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio <= lac.dtinicio) + coalesce(an.numpartoentrada,0)) as ordem_lac
    , lac.dtinicio
    , lac.dtfim
    , (select sp.descricao from sp_grupoanimalespecifico(da.dtinicio, (select conf.valor from configuracao conf where conf.nome = 'TipoGrupoPrincipal'), an.cdanimal) sp) as Grupo
    , cast(d.nomeresumido as varchar (50)) as Evento
    , da.dtinicio as Data_Evento
    , cast( (da.dtfim - da.dtinicio) as decimal (5,3)) as Complemento_Evento
    , cast(null as varchar (300)) as Complemento_Evento_Texto
    , (da.dtinicio - lac.dtinicio) as DEL
from
    animal an
    left join lactacao lac on lac.cdanimal = an.cdanimal
    join doencaanimal da on da.cdanimal = an.cdanimal
    join doenca d on d.cddoenca = da.cddoenca
where
  an.cdcategoria in (6,7)
  and an.animalrebanho = 1
  and an.tipoanimal = 'A'

union all

---5 Aplicao de produto
select
    an.numero
    , an.dtnascimento
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue
    , ((select count(*) from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio <= lac.dtinicio) + coalesce(an.numpartoentrada,0)) as ordem_lac
    , lac.dtinicio
    , lac.dtfim
    , (select sp.descricao from sp_grupoanimalespecifico(ap.dtaplicacaoproduto, (select conf.valor from configuracao conf where conf.nome = 'TipoGrupoPrincipal'), an.cdanimal) sp) as Grupo
    , cast(p.nome as varchar (50)) as Evento
    , ap.dtaplicacaoproduto as Data_Evento
    , cast(null as decimal (5,3)) as Complemento_Evento
    , cast(null as varchar (300)) as Complemento_Evento_Texto
    , (ap.dtaplicacaoproduto - lac.dtinicio) as DEL
from
    animal an
    left join lactacao lac on lac.cdanimal = an.cdanimal
    join aplicacaoproduto ap on ap.cdanimal = an.cdanimal
    join produto p on p.cdproduto = ap.cdproduto
where
  an.cdcategoria in (6,7)
  and an.animalrebanho = 1
  and an.tipoanimal = 'A'

union all

---6 Mastite
select
    an.numero
    , an.dtnascimento
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue
    , ((select count(*) from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio <= lac.dtinicio) + coalesce(an.numpartoentrada,0)) as ordem_lac
    , lac.dtinicio
    , lac.dtfim
    , (select sp.descricao from sp_grupoanimalespecifico(m.data, (select conf.valor from configuracao conf where conf.nome = 'TipoGrupoPrincipal'), an.cdanimal) sp) as Grupo
    , cast('Mastite' as varchar (50)) as Evento
    , m.data as Data_Evento
    , cast( null as decimal (5,3)) as Complemento_Evento
    , cast(t.nome as varchar (300)) as Complemento_Evento_Texto
    , (m.data - lac.dtinicio) as DEL
from
    animal an
    left join lactacao lac on lac.cdanimal = an.cdanimal
    join mamite m on m.cdanimal = an.cdanimal and ((m.ad <> 3) or (m.ae <> 3) or (m.pd <> 3) or (m.pe <> 3))
    left join tratamentobase t on t.cdtratamentobase = m.cdtratamentobase
where
  an.cdcategoria in (6,7)
  and an.animalrebanho = 1
  and an.tipoanimal = 'A'

union all

---7 Baixa
select
    an.numero
    , an.dtnascimento
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue
    , ((select count(*) from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio <= lac.dtinicio) + coalesce(an.numpartoentrada,0)) as ordem_lac
    , lac.dtinicio
    , lac.dtfim
    , (select sp.descricao from sp_grupoanimalespecifico(an.dtbaixa, (select conf.valor from configuracao conf where conf.nome = 'TipoGrupoPrincipal'), an.cdanimal) sp) as Grupo
    , cast('Baixa' as varchar (50)) as Evento
    , an.dtbaixa as Data_Evento
    , cast( null as decimal (5,3)) as Complemento_Evento
    , cast(('Tipo baixa: ' || tb.descricao || ' - Motivo baixa: ' || mb.descricao || '.') as varchar (300)) as Complemento_Evento_Texto
    , (an.dtbaixa - lac.dtinicio) as DEL
from
    animal an
    left join lactacao lac on lac.cdlactacao =
        (select first 1 re.cdlactacao
        from lactacao re
        where re.cdanimal = an.cdanimal
        order by re.dtinicio desc)
    left join tipobaixa tb on tb.cdtipobaixa = an.cdtipobaixa
    left join motivobaixa mb on mb.cdmotivobaixa = an.cdmotivobaixa
where
  an.dtbaixa is not null
  and an.cdcategoria in (6,7)
  and an.animalrebanho = 1
  and an.tipoanimal = 'A'

union all

---8 Parto
select
    an.numero
    , an.dtnascimento
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue
    , ((select count(*) from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio <= lac.dtinicio) + coalesce(an.numpartoentrada,0)) as ordem_lac
    , lac.dtinicio
    , lac.dtfim
    , (select sp.descricao from sp_grupoanimalespecifico(an.dtbaixa, (select conf.valor from configuracao conf where conf.nome = 'TipoGrupoPrincipal'), an.cdanimal) sp) as Grupo
    , cast('Parto' as varchar (50)) as Evento
    , rep.data as Data_Evento
    , cast( null as decimal (5,3)) as Complemento_Evento
    , cast(((case
      when rep.retencaoplacenta = 1 then 'RP: Sim'
      else 'RP: No' end) || (case when (rep.observacao is null or (rep.observacao = '') ) then '' else ' | '
      || rep.observacao end)) as varchar (300)) as Complemento_Evento_Texto
    , (an.dtbaixa - lac.dtinicio) as DEL
from
    animal an
    left join lactacao lac on lac.cdanimal = an.cdanimal
    join reproducao rep on rep.cdanimal = lac.cdanimal and rep.data = lac.dtinicio and rep.cdtiporeproducao = 7
where
  an.cdcategoria in (6,7)
  and an.animalrebanho = 1
  and an.tipoanimal = 'A'

union all

---8 Peso
select
    an.numero
    , an.dtnascimento
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue
    , ((select count(*) from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio <= lac.dtinicio) + coalesce(an.numpartoentrada,0)) as ordem_lac
    , lac.dtinicio
    , lac.dtfim
    , (select sp.descricao from sp_grupoanimalespecifico(an.dtbaixa, (select conf.valor from configuracao conf where conf.nome = 'TipoGrupoPrincipal'), an.cdanimal) sp) as Grupo
    , cast('Peso' as varchar (50)) as Evento
    , p.dtpeso as Data_Evento
    , cast(p.peso as decimal (5,3)) as Complemento_Evento
    , cast(tp.descricao as varchar (300)) as Complemento_Evento_Texto
    , (an.dtbaixa - lac.dtinicio) as DEL
from
    animal an
    left join lactacao lac on lac.cdanimal = an.cdanimal
    join peso p on p.cdanimal = lac.cdanimal
    join tipopeso tp on tp.cdtipopeso = p.cdtipopeso
where
  an.cdcategoria in (6,7)
  and an.animalrebanho = 1
  and an.tipoanimal = 'A'

order by
    1,5,9
